#ifndef __Metadata_h__
#define __Metadata_h__

#include <string>

class Metadata {
public:
	Metadata(const std::string& t, unsigned long s, unsigned long l) :
	     type(t), type_size(s), length(l) {};
	virtual ~Metadata() {};
	inline std::string get_type(void) const { return type; };
	inline unsigned long get_type_size(void) const { return type_size; };
	inline unsigned long get_len(void) const { return length; };
	inline unsigned long get_tot_size(void) const 
						{ return length * type_size; };
protected:
	std::string type;
	unsigned long type_size;
	unsigned long length;
};
#endif // __Metadata_h__
