#include "FactoryExample1.h"
#include <iostream>

using namespace std;

DisneyUser::DisneyUser()
{
	const int config[] = {GOOFY_ID, PLUTO_ID, PLUTO_ID, 1234/*invalid*/};

	len_toons = 4;
	toons = new DisneyProduct*[4];
	for (size_t i = 0; i < 4; i++)
		toons[i] = create_cartoon(config[i]);
}

DisneyUser::~DisneyUser() 
{
	for (size_t i = 0; i < len_toons; i++)
		if (toons[i])
			delete toons[i];
	delete[] toons;
}

DisneyProduct* DisneyUser::create_cartoon(int id)
{
	DisneyFactory factory;
	switch(id) {
	case GOOFY_ID:
		return factory.create_goofy();
	case PLUTO_ID:
		return factory.create_pluto();
	}
	return NULL;
}

void DisneyUser::animate(void)
{
	for (size_t i = 0; i < len_toons; i++)
		if (toons[i])
			cout << "Hullo, my name is " << 
			        toons[i]->get_name() << endl;
}


int main(void)
{
	cout << "Example: " << __FILE__ << endl << endl;

	{
	DisneyUser u;
	u.animate();
	} // ~DisneyUser() is called here!

	cout << endl << "Example terminates " << endl;

	return 0;
}
