#include "FactoryExample2.h"
#include <iostream>

using namespace std;

DisneyProduct* DisneyFactory::create(int id)
{
	switch(id) {
	case GOOFY_ID:
		return new Goofy();
	case PLUTO_ID:
		return new Pluto();
	}
	return NULL;
}

DisneyUser::DisneyUser()
{
	const int config[] = {GOOFY_ID, PLUTO_ID, 
                              PLUTO_ID, 1234/*invalid*/};

	DisneyFactory factory;

	for (size_t i = 0; i < 4; i++) {
		DisneyProduct *p = factory.create(config[i]);
		if (p)
			toons.push_back(p);
	}
}

DisneyUser::~DisneyUser() 
{
	vector<DisneyProduct*>::iterator it;
	for (it = toons.begin(); it != toons.end(); ++it)
		delete *it;
}

void DisneyUser::animate(void)
{
	vector<DisneyProduct*>::const_iterator it;
	for (it = toons.begin(); it != toons.end(); ++it)
		cout << "Hullo, my name is " << (*it)->get_name() << endl;
}

int main(void)
{
	cout << "Example: " << __FILE__ << endl << endl;

	{
	DisneyUser u;
	u.animate();
	} // ~DisneyUser() is called here!

	cout << endl << "Example terminates " << endl;

	return 0;
}
