#include <string>
#include <vector>

enum DisneyCharacterID {
	GOOFY_ID = 0,
	PLUTO_ID = 1,
};

class DisneyProduct {
public:
	virtual ~DisneyProduct() {};
	inline std::string get_name(void) const { return name; };
protected:
	DisneyProduct(const std::string& n) : name(n) {};
private:
	DisneyProduct(const DisneyProduct&);
	DisneyProduct &operator=(const DisneyProduct&);
	std::string name;
};

class DisneyFactory;

class Goofy : public DisneyProduct {
private:
	Goofy() : DisneyProduct("goofy") {};
	friend class DisneyFactory;
};

class Pluto : public DisneyProduct {
private:
	Pluto() : DisneyProduct("pluto") {};
	friend class DisneyFactory;
};

class DisneyFactory {
public:
	DisneyProduct* create(int id);
};

class DisneyUser {
public:
	DisneyUser();
	~DisneyUser(); 
	void animate(void);
private:
	std::vector<DisneyProduct*> toons;
};
